\documentclass[handout]{beamer}
\usepackage[utf8]{inputenc}
\usepackage[T1]{fontenc}
\usepackage{amsmath}
\usepackage{amssymb}
\usepackage{mathtools}
\usepackage{pgf}
\usepackage{tikz}
\usepackage{tikz-qtree}
\usepackage[sc]{mathpazo}
\usepackage[nice]{nicefrac}
\usepackage{epstopdf}
\usepackage{graphicx}
\usepackage{pstricks}

\usetheme{Singapore}

\begin{document}
\title{How to go forward in better large models in Dynare?}
\subtitle{25th Central Bank Macroeconomic Modeling Workshop}
\date{Ispra, November 24, 2022}
\author{Michel Juillard\thanks{Banque de France, michel.juillard@mjui.fr}}

\begin{frame}
  \titlepage
{\footnotesize The views expressed herein are ours and do not
necessarily represent the views of Banque de France.}
\end{frame}

\begin{frame}
  \frametitle{Introduction}
  \begin{itemize}
  \item Very large models
    \begin{itemize}
    \item Multicountry models
    \item Climate economic models
    \item Heterogenous agent models
    \end{itemize}
  \item Outline
    \begin{enumerate}
    \item A  benchmark problem
    \item Preprocessing
    \item Compiling
    \item Evaluating the residuals
    \item Making the Jacobian of the stacked model
    \item Solving the linear problem inside Newton algorithm
    \end{enumerate}
  \end{itemize}
\end{frame}

\begin{frame}
  \frametitle{A big model benchmark case}
  A large multi-region models with
  \begin{enumerate}
  \item 10 symmetric regions
  \item 20 symmetric regions
  \item 30 symmtric regions
  \end{enumerate}
  simulated over 610 periods
\end{frame}

\begin{frame}
  \frametitle{Preprocessing}
  \begin{itemize}
  \item Translating Dynare equations in Julia or Matlab + computing
    the derivatives
  \item For 30 region model, it takes about 7 seconds 400 MO RAM
  \end{itemize}
\end{frame}

\begin{frame}
  \frametitle{Compiling}
  \begin{itemize}
  \item Matlab
    \begin{itemize}
    \item Matlab
    \item bytecode
    \item use\_dll
    \end{itemize}
  \item Julia
    \begin{itemize}
    \item precompiling (type inference)
    \item JIT compiling
    \end{itemize}
  \item Saving precompiled models
  \end{itemize}
\end{frame}

\begin{frame}
  \frametitle{Evaluating the residuals}
  \begin{itemize}
  \item The easiest step
  \item Can be parallelized. Is it worth it?
  \item In Julia, difficulty with functions that don't accept negative
    arguments as the result would be complex
    \begin{itemize}
    \item $log(x)$
    \item $\sqrt{x}$
    \item $x^a$, when $a$ is fractional
    \end{itemize}
    \item can be solved with additional auxiliary variables
  \end{itemize}
\end{frame}

\begin{frame}
  \frametitle{Making Jacobian of stacked model}
  \begin{itemize}
  \item Building sparse Jacobian for stacked model from sparse Jacobian of the period
    model
  \item Updating Jacobian: only evaluate non-zeros elements
  \item Can be parallelized
  \end{itemize}
\end{frame}

\begin{frame}
  \frametitle{Solving the linear problem inside Newton method}
  \begin{itemize}
  \item Sparse LU factorization
    \begin{itemize}
    \item Sparse suite (UMFPACK)
    \item Pardiso solver
    \end{itemize}
  \item Krylov methods
    \begin{itemize}
    \item iterative methods
    \item require pre-conditioner
    \end{itemize}
  \item Optimal algorithm choice depends on sparse structure
  \item We need testing different models
  \end{itemize}
\end{frame}

\begin{frame}
  \frametitle{Temporary conclusion}
  \begin{itemize}
  \item Many trade-offs
  \item Search for avoidable memory allocations
  \item Right amount of effort in precompiling
  \item Explore sparse linear solvers
  \item Set a benchmark machine 
  \item Release regular benchmarks
  \end{itemize}
\end{frame}


\end{document}
%%% Local Variables:
%%% mode: latex
%%% TeX-master: t
%%% End:
